MM = LibStub("AceAddon-3.0"):NewAddon("MikaMounter","AceConsole-3.0","AceEvent-3.0");
local AceLocale = LibStub("AceLocale-3.0");
local L = AceLocale:GetLocale("MikaMounter");
MikaMounterPrefs = {
	dislikes = {},
	favourites = {},
	favouritesActive = false,
	dislikesActive = false
}
BINDING_HEADER_MIKA_MOUNTER = "Mika Mounter";
BINDING_NAME_MOUNT_AUTO = L["Flying or ground mount"];
BINDING_NAME_MOUNT_GROUND = L["Ground mount"];

walkRidingMounts = {
	30174, -- Riding Turtle
}
qirajRidingMounts = {
	25953, -- Blue Qiraji Battle Tank
	26054, -- Red Qiraji Battle Tank
	26055, -- Yellow Qiraji Battle Tank
	26056, -- Green Qiraji Battle Tank
	26656, -- Black Qiraji Battle Tank
}

-- FKA 60%/100% Mounts
groundMounts = {
	458, -- Brown Horse
	470, -- Black Stallion
	472, -- Pinto
	580, -- Timber Wolf
	5784, -- Summon Felsteed
	6648, -- Chestnut Mare
	6653, -- Dire Wolf
	6654, -- Brown Wolf
	6777, -- Gray Ram
	6898, -- White Ram
	6899, -- Brown Ram
	8394, -- Striped Frostsaber
	8395, -- Emerald Raptor
	10789, -- Spotted Frostsaber
	10793, -- Striped Nightsaber
	10796, -- Turquoise Raptor
	10799, -- Violet Raptor
	10873, -- Red Mechanostrider
	10969, -- Blue Mechanostrider
	13769, -- Summon Warhorse (Alliance)
	15779, -- White Mechanostrider Mod B
	16055, -- Black Nightsaber
	16056, -- Ancient Frostsaber
	16080, -- Red Wolf
	16081, -- Winter Wolf
	16082, -- Palomino
	16083, -- White Stallion
	16084, -- Mottled Red Raptor
	17229, -- Winterspring Frostsaber
	17450, -- Ivory Raptor
	17453, -- Green Mechanostrider
	17454, -- Unpainted Mechanostrider
	17458, -- Fluorescent Green Mechanostrider
	17459, -- Icy Blue Mechanostrider Mod A
	17460, -- Frost Ram
	17461, -- Black Ram
	17462, -- Red Skeletal Horse
	17463, -- Blue Skeletal Horse
	17464, -- Brown Skeletal Horse
	17465, -- Green Skeletal Warhorse
	17481, -- Rivendare's Deathcharger
	18922, -- Teal Kodo
	18989, -- Gray Kodo
	18990, -- Brown Kodo
	18991, -- Green Kodo
	22717, -- Black War Steed
	22718, -- Black War Kodo
	22719, -- Black Battlestrider
	22720, -- Black War Ram
	22721, -- Black War Raptor
	22722, -- Red Skeletal Warhorse
	22723, -- Black War Tiger
	22724, -- Black War Wolf
	23161, -- Summon Dreadsteed
	23214, -- Summon Charger (Alliance)
	23219, -- Swift Mistsaber
	23221, -- Swift Frostsaber
	23222, -- Swift Yellow Mechanostrider
	23223, -- Swift White Mechanostrider
	23225, -- Swift Green Mechanostrider
	23227, -- Swift Palomino
	23228, -- Swift White Steed
	23229, -- Swift Brown Steed
	23238, -- Swift Brown Ram
	23239, -- Swift Gray Ram
	23240, -- Swift White Ram
	23241, -- Swift Blue Raptor
	23242, -- Swift Olive Raptor
	23243, -- Swift Orange Raptor
	23246, -- Purple Skeletal Warhorse
	23247, -- Great White Kodo
	23248, -- Great Grey Kodo
	23249, -- Great Brown Kodo
	23250, -- Swift Brown Wolf
	23251, -- Swift Timber Wolf
	23252, -- Swift Gray Wolf
	23338, -- Swift Stormsaber
	23509, -- Frostwolf Howler
	23510, -- Stormpike Battle Charger
	24242, -- Swift Razzashi Raptor
	24252, -- Swift Zulian Tiger
	26656, -- Black Qiraji Battle Tank
	33660, -- Swift Pink Hawkstrider
	34406, -- Brown Elekk
	34767, -- Summon Charger (Horde)
	34769, -- Summon Warhorse (Horde)
	34790, -- Dark War Talbuk
	34795, -- Red Hawkstrider
	34896, -- Cobalt War Talbuk
	34897, -- White War Talbuk
	34898, -- Silver War Talbuk
	34899, -- Tan War Talbuk
	35018, -- Purple Hawkstrider
	35020, -- Blue Hawkstrider
	35022, -- Black Hawkstrider
	35025, -- Swift Green Hawkstrider
	35027, -- Swift Purple Hawkstrider
	35028, -- Swift Warstrider
	35710, -- Gray Elekk
	35711, -- Purple Elekk
	35712, -- Great Green Elekk
	35713, -- Great Blue Elekk
	35714, -- Great Purple Elekk
	36702, -- Fiery Warhorse
	39315, -- Cobalt Riding Talbuk
	39316, -- Dark Riding Talbuk
	39317, -- Silver Riding Talbuk
	39318, -- Tan Riding Talbuk
	39319, -- White Riding Talbuk
	41252, -- Raven Lord
	42776, -- Spectral Tiger
	42777, -- Swift Spectral Tiger
	43688, -- Amani War Bear
	43899, -- Brewfest Ram
	43900, -- Swift Brewfest Ram
	46628, -- Swift White Hawkstrider
	48025, -- Headless Horsemans Mount
	48027, -- Black War Elekk
	48778, -- Acherus Deathcharger
	49322, -- Swift Zhevra
	49378, -- Brewfest Riding Kodo
	49379, -- Great Brewfest Kodo
	50869, -- Brewfest Kodo
	51412, -- Big Battle Bear
	54753, -- White Polar Bear Mount
	55531, -- Mechano-Hog
	58983, -- Big Blizzard Bear
	59785, -- Black War Mammoth (Alliance)
	59788, -- Black War Mammoth (Horde)
	59791, -- Wooly Mammoth (Alliance)
	59793, -- Wooly Mammoth (Horde)
	59797, -- Ice Mammoth (Horde)
	59799, -- Ice Mammoth (Alliance)
	60114, -- Armored Brown Bear (Alliance)
	60116, -- Armored Brown Bear (Horde)
	60118, -- Black War Bear (Alliance)
	60119, -- Black War Bear (Horde)
	60424, -- Mekgineer's Chopper
	61425, -- Traveler's Tundra Mammoth (Alliance)
	61447, -- Traveler's Tundra Mammoth (Horde)
	61469, -- Grand Ice Mammoth (Horde)
	61470, -- Grand Ice Mammoth (Alliance)
	63232, -- Swift Elwynn Steed
	63635, -- Swift Darkspear Raptor
	63636, -- Swift Ironforge Ram
	63637, -- Swift Darnassian Mistsaber
	63638, -- Turbostrider
	63639, -- Great Azuremyst Elekk
	63640, -- Swift Orgrimmar Wolf
	63641, -- Great Mulgore Kodo
	63642, -- Swift Silvermoon Hawkstrider
	63643, -- Swift Forsaken Warhorse
	64657, -- White Kodo
	64658, -- Black Wolf
	64659, -- Venomhide Ravasaur
	64977, -- Black Skeletal Horse
	65639, -- Swift Red Hawkstrider
	65641, -- Great Golden Kodo
	65644, -- Swift Purple Raptor
	65645, -- White Skeletal Warhorse
	65646, -- Swift Burgundy Wolf
	66091, -- Sunreaver Hawkstrider
	66846, -- Ochre Skeletal Warhorse
	67466, -- Argent Warhorse
	69820, -- Summon Sunwalker Kodo
	69826, -- Summon Great Sunwalker Kodo
	73629, -- Summon Exarch's Elekk
	73630, -- Summon Great Exarch's Elekk
	75614, -- Celestial Steed
	84751, -- Fossilized Raptor
	87090, -- Goblin Trike
	87091, -- Goblin Turbo-Trike
	88748, -- Brown Riding Camel
	88749, -- Tan Riding Camel
	88750, -- Grey Riding Camel
	89520, -- Goblin Mini Hotrod
	90621, -- Golden King
	92155, -- Ultramarine Qiraji Battle Tank
	92231, -- Spectral Steed
	92232, -- Spectral Wolf
	93644, -- Kor'kron Annihilator
	96491, -- Armored Razzashi Raptor
	96499, -- Swift Zulian Panther
	97581, -- Savage Raptor
	98204, -- Amani Battle Bear
	98727, -- Winged Guardian
	100332, -- Vicious War Steed
	100333, -- Vicious War Wolf
	101542, -- Flametalon of Alyzrazor
	101573, -- Swift Shorestrider
	102349, -- Swift Springstrider
	102346, -- Swift Forest Strider
	102350, -- Swift Lovebird
	102488, -- White Riding Camel
	103081, -- Darkmoon Dancing Bear
	103195, -- Mountain Horse
	103196, -- Swift Mountain Horse
	107203, -- Tyrael's Charger
	110051, -- Heart Of The Aspects
	118089, -- Azure Water Strider
	118737, -- Pandaren Kite
	120043, -- Jeweled Onyx Panther
	120395, -- Green Dragon Turtle
	120822, -- Great Red Dragon Turtle
	121836, -- Sapphire Panther
	121837, -- Jade Panther
	121838, -- Ruby Panther
	121839, -- Sunstone Panther
	122708, -- Grand Expedition Yak
	123160, -- Crimson Riding Crane
	123182, -- White Riding Yak
	123886, -- Amber Scorpion
	124659, -- Imperial Quilen
	126507, -- Depleted-Kyparium Rocket
	127174, -- Azure Riding Crane
	127176, -- Golden Riding Crane
	127177, -- Regal Riding Crane
	127178, -- Jungle Riding Crane
	127180, -- Albino Riding Crane
	127209, -- Black Riding Yak
	127213, -- Brown Riding Yak
	127216, -- Grey Riding Yak
	127220, -- Blonde Riding Yak
	127268, -- Black Dragon Turtle
	127271, -- Crimson Water Strider
	127272, -- Orange Water Strider
	127274, -- Jade Water Strider
	127278, -- Golden Water Strider
	127286, -- Black Dragon Turtle
	127287, -- Blue Dragon Turtle
	127288, -- Brown Dragon Turtle
	127289, -- Purple Dragon Turtle
	127290, -- Red Dragon Turtle
	127293, -- Great Green Dragon Turtle
	127295, -- Great Black Dragon Turtle
	127298, -- Purple Dragon Turtle
	127302, -- Great Blue Dragon Turtle
	127308, -- Great Brown Dragon Turtle
	127310, -- Great Purple Dragon Turtle
	129932, -- Green Shado-Pan Riding Tiger
	129934, -- Blue Shado-Pan Riding Tiger
	129935, -- Red Shado-Pan Riding Tiger
	130086, -- Brown Riding Goat
	130092, -- Red Flying Cloud
	130137, -- White Riding Goat
	130138, -- Black Riding Goat
	130965, -- Son of Galleon
	130985, -- Pandaren Kite
	134573, -- Swift Windsteed
	135416, -- Grand Armored Gryphon
	135418, -- Grand Armored Wyvern
	136163, -- Grand Gryphon
	136164, -- Grand Wyvern
}
-- FKA 150%, 280% then 310% Mounts
flyingMounts = {
	32235, -- Golden Gryphon
	32239, -- Ebon Gryphon
	32240, -- Snowy Gryphon
	32242, -- Swift Blue Gryphon
	32243, -- Tawny Wind Rider
	32244, -- Blue Wind Rider
	32245, -- Green Wind Rider
	32246, -- Swift Red Wind Rider
	32289, -- Swift Red Gryphon
	32290, -- Swift Green Gryphon
	32292, -- Swift Purple Gryphon
	32295, -- Swift Green Wind Rider
	32296, -- Swift Yellow Wind Rider
	32297, -- Swift Purple Wind Rider
	37015, -- Swift Nether Drake
	39798, -- Green Nether Ray
	39800, -- Red Nether Ray
	39801, -- Purple Nether Ray
	39802, -- Silver Nether Ray
	39803, -- Blue Nether Ray
	40192, -- Ashes of Al'ar
	41513, -- Onyx Nether Drake
	41514, -- Azure Nether Drake
	41515, -- Cobalt Nether Drake
	41516, -- Purple Nether Drake
	41517, -- Veridian Nether Drake
	41518, -- Violet Nether Drake
	43810, -- Frost Wyrm
	43927, -- Cenarion War Hippogryph
	44151, -- Turbo-Charged Flying Machine
	44153, -- Flying Machine
	44744, -- Merciless Nether Drake
	46197, -- X-51 Nether-Rocket
	46199, -- X-51 Nether-Rocket X-TREME
	48025, -- Headless Horsemans Mount
	49193, -- Vengeful Nether Drake
	51960, -- Frostwyrm
	54729, -- Winged Steed of the Ebon Blade
	58615, -- Brutal Nether Drake
	59567, -- Azure Drake (Maly 25)
	59568, -- Blue Drake (Maly 10)
	59569, -- Bronze Drake
	59570, -- Red Drake (Wyrmrest Accord)
	59571, -- Twilight Drake (Sartharion hard mode 25-man)
	59650, -- Black Drake (Sartharion hard mode 10-man)
	59961, -- Red Proto-Drake (Glory of the Hero)
	59976, -- Black Proto-Drake (Glory of the Heroic Raider)
	59996, -- Blue Proto-Drake
	60002, -- Time-Lost Proto-Drake
	60021, -- Plagued Proto-Drake (Glory of the Raider)
	60024, -- Violet Proto-Drake (What A Strange Trip It Has Been)
	60025, -- Albino Drake
	61229, -- Armored Snowy Gryphon
	61230, -- Armored Blue Wind Rider
	61294, -- Green Proto-Drake
	61309, -- Magnificent Flying Carpet
	61451, -- Flying Carpet
	61997, -- Red Dragonhawk
	62042, -- Black Dragonhawk
	63796, -- Mimiron's Head
	63844, -- Argent Hippogryph
	63956, -- Ironbound Proto-Drake (Heroic Ulduar Raider)
	63963, -- Rusted Proto-Drake (Ulduar Raider)
	64927, -- Deadly Gladiator's Frostwyrm
	66088, -- Sunreaver Dragonhawk
	72807, -- Icebound Frostbrood Vanquisher
	72808, -- Bloodbathed Frostblood Vanquisher
	75614, -- Celestial Steed
	75596, -- Frosty Flying Carpet
	75973, -- X-53 Touring Rocket
	88331, -- Volcanic Stone Drake
	88335, -- Drake of the East Wind
	88718, -- Phosphorescent Stone Drake
	88741, -- Drake of the West Wind
	88742, -- Drake of the North Wind
	88744, -- Drake of the South Wind
	88746, -- Vitreous Stone Drake
	88990, -- Dark Phoenix
	93326, -- Sandstone Drake
	93463, -- Mottled Drake
	93623, -- Mottled Drake
	96503, -- Amani Dragonhawk
	97359, -- Flameward Hippogryph
	97493, -- Crimson Fire Hawk
	97501, -- Beryl Fire Hawk
	97560, -- Corrupted Fire Hawk
	98727, -- Winged Guardian
	101282, -- Vicious Gladiator's Twilight Drake
	101821, -- Ruthless Gladiator's Twilight Drake
	102514, -- Corrupted Hippogryph
	107203, -- Tyrael's Charger
	107516, -- Spectral Gryphon
	107517, -- Spectral Wind Rider
	107842, -- Blazin Drake
	107844, -- Twilight Harbinger
	107845, -- Life-Binder's Handmaiden
	110039, -- Experiment 12-B
	110051, -- Heart Of The Aspects
	113120, -- Feldrake
	113199, -- Jade Cloud Serpent
	118737, -- Pandaren Kite
	121820, -- Obsidian Nightwing
	123992, -- Azure Cloud Serpent
	123993, -- Golden Cloud Serpent
	124408, -- Thundering Jade Cloud Serpent
	124550, -- Cataclysmic Gladiator's Twilight Drake
	124659, -- Imperial Quilen
	126507, -- Depleted-Kyparium Rocket
	126508, -- Geosynchronous World Spinner
	127154, -- Onyx Cloud Serpent
	127156, -- Crimson Cloud Serpent
	127158, -- Heavenly Onyx Cloud Serpent
	127161, -- Heavenly Crimson Cloud Serpent
	127164, -- Heavenly Golden Cloud Serpent
	127165, -- Heavenly Jade Cloud Serpent
	127169, -- Heavenly Azure Cloud Serpent
	127170, -- Astral Cloud Serpent
	129552, -- Crimson Pandaren Phoenix
	129918, -- Thundering August Cloud Serpent
	130092, -- Red Flying Cloud
	130985, -- Pandaren Kite
	132036, -- Thundering Ruby Cloud Serpent
	132117, -- Ashen Pandaren Phoenix
	132118, -- Emerald Pandaren Phoenix
	132119, -- Violet Pandaren Phoenix
	133023, -- Jade Pandaren Kite
	134573, -- Swift Windsteed
	135416, -- Grand Armored Gryphon
	135418, -- Grand Armored Wyvern
	136163, -- Grand Gryphon
	136164, -- Grand Wyvern
}

skillMounts = {
	[44151] = L['Engineering'], -- Turbo-Charged Flying Machine - Engineer Only
	[44153] = L['Engineering'], -- Flying Machine - Engineer Only
	
	
	[61309] = L['Tailoring'], -- Magnificent Flying Carpet - Tailor Only
	[61451] = L['Tailoring'], -- Flying Carpet - Tailor Only
	[75596] = L['Tailoring'], -- Frosty Flying Carpet - Tailor Only
	[118737] = L['Tailoring'], -- Pandaren Kite - Tailor Only
	[130985] = L['Tailoring'], -- Pandaren Kite - Tailor Only


	[113199] = L['Cloud Serpent Riding'], -- Jade Cloud Serpent
	[123992] = L['Cloud Serpent Riding'], -- Azure Cloud Serpent
	[123993] = L['Cloud Serpent Riding'], -- Golden Cloud Serpent
	[124408] = L['Cloud Serpent Riding'], -- Thundering Jade Cloud Serpent
	[127154] = L['Cloud Serpent Riding'], -- Onyx Cloud Serpent
	[127156] = L['Cloud Serpent Riding'], -- Crimson Cloud Serpent
	[127158] = L['Cloud Serpent Riding'], -- Heavenly Onyx Cloud Serpent
	[127161] = L['Cloud Serpent Riding'], -- Heavenly Crimson Cloud Serpent
	[127164] = L['Cloud Serpent Riding'], -- Heavenly Golden Cloud Serpent
	[127165] = L['Cloud Serpent Riding'], -- Heavenly Jade Cloud Serpent
	[127169] = L['Cloud Serpent Riding'], -- Heavenly Azure Cloud Serpent
	[127170] = L['Cloud Serpent Riding'], -- Astral Cloud Serpent
	[129918] = L['Cloud Serpent Riding'], -- Thundering August Cloud Serpent
	[132036] = L['Cloud Serpent Riding'], -- Thundering Ruby Cloud Serpent
	
}

-- AKA "The Achievement Turtle"
waterMounts = {
	64731, -- Sea Turtle
}
-- AKA "Abyssal Seahorse"
fastWaterMounts = {
	75207, -- Abyssal Seahorse
}
-- Vashj'ir
deepWaterZones = {
	L["Shimmering Expanse"],
	L["Abyssal Depths"],
	L["Kelp'thar Forest"]
	
}
noFlyZones = {
	L["Throne of the Four Winds"],
	L["The Deadmines"],
}
noFlyInstances = {
	L["Scarlet Monastery"],
	L["A Brewing Storm"],
	L["Arena of Annihilation"],
	L["Brewmoon Festival"],
	L["Crypt of Forgotten Kings"],
	L["Greenstone Village"],
	L["Theramore's Fall"],
	L["Unga Ingoo"],
	L["Dagger in the Dark"],
	L["Assault on Zan'vess"],
	L["Domination Point"],
	L["Lion's Landing"],
	L["A Little Patience"]
}

worldPVPZones = {
	Wintergrasp = 1, -- Wintergrasp
	TolBarad = 2, -- Tol Barad
}

MM.options = {
	name = "MikaMounter",
	type = "group",
	handler = MM,
	args = {
		mount = {
			type = "execute",
			name = "Mount random mount",
			desc = L["Mount random mount depending on your location"],
			func = "Mount",
		},
		mountground = {
			type = "execute",
			name = "Mount random ground mount",
			desc = L["Mount random ground mount no matter if you can fly or not"],
			func = "MountGround",
		},
		list = {
			type = "group",
			name = "List items",
			desc = L["List some things"],
			args = {
				mounts = {
					type = "execute",
					name = "List mounts and spell IDs",
					desc = L["List your mounts and summoning spell IDs"],
					func = "ListMounts",
				},
				newmounts = {
					type = "execute",
					name = "List mounts unknown to this addon",
					desc = L["List mounts unknown to this addon"],
					func = "ListUnknownMounts",
				},
				mountcount = {
					type = "execute",
					name = "List mount amounts for each mountgroup",
					desc = L["List mount amounts for each mount group"],
					func = "listMountAmounts",
				},
			},
		},
		toggle = {
			type = "group",
			name = "Toggle flags",
			desc = L["Toggle flags"],
			args = {
				favourite = {
					type = "input",
					name = "Add or remove favourite",
					desc = L["Add or remove favourite"],
					get = "Nothing",
					set = "ToggleFavourite",
				},
				dislike = {
					type = "input",
					name = "Add or remove dislike",
					desc = L["Add or remove dislike"],
					get = "Nothing",
					set = "ToggleDislike",
				},
				favourites = {
					type = "execute",
					name = "Toggle favourites",
					desc = L["Toggle favourites"],
					func = "ToggleFavourites",
				},
				dislikes = {
					type = "execute",
					name = "Toggle dislikes",
					desc = L["Toggle dislikes"],
					func = "ToggleDislikes",
				},
			}
		}
	}
}	

function MM:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MikaMounter", MM.options, {"mm", "mikamounter"});
	MM:RegisterEvent("UNIT_INVENTORY_CHANGED");
	MM:RegisterEvent("UNIT_PET");
	MM:RegisterEvent("UNIT_AURA");
	MM:RegisterEvent("UNIT_ENTERED_VEHICLE");
	MM:RegisterEvent("ITEM_LOCK_CHANGED");
	MM:RegisterEvent("WORLD_MAP_UPDATE");
	MM.actionbutton = CreateFrame("Button", "MountButton", UIParent, "SecureHandlerShowHideTemplate, SecureHandlerEnterLeaveTemplate, SecureHandlerStateTemplate, SecureActionButtonTemplate");
	MM.actionbutton:RegisterForClicks("LeftButtonDown", "RightButtonDown");
	MM.actionbutton:SetAttribute("type","item");
	MM.actionbutton:Show();
	--MM:RegisterChatCommand("/mikamount", "MM:SlashCommand");
end

function MM:MountGround()
	if ( ( ( IsMounted() == 1 ) or ( CanExitVehicle() == 1 ) ) and ( IsFlying() == nil ) ) then
		if ( IsMounted() ) then
			Dismount();
			return true;
		else
			VehicleExit();
			return true;
		end
	else
		local mountCount = GetNumCompanions("MOUNT");
		if ( mountCount == 0 ) then
			-- Keine Mounts, keine Aktion
			return false;
		end;
		local mountNumber = 0;
		local mountTables = {};
		if ( GetRealZoneText() == L["Ahn'Qiraj"] ) then table.insert(mountTables,MM:IntersectTables(qirajRidingMounts)); end;
		if ( IsSwimming() == 1 ) then 
			if (MM:findValue(deepWaterZones,GetRealZoneText())) then table.insert(mountTables,MM:IntersectTables(fastWaterMounts)); end;
			table.insert(mountTables,MM:IntersectTables(waterMounts));
		end;
		table.insert(mountTables,MM:IntersectTables(groundMounts));
		table.insert(mountTables,MM:IntersectTables(walkRidingMounts));
		local mountTable = {};
		local mountCount = 0;
		local mountNumbers = {};
		for i = 1, table.getn(mountTables) do
			if ( mountCount == 0 ) then
				mountTable = mountTables[i];
				mountNumbers = MM:getMountNumbers(mountTable);
				mountCount = table.getn(mountNumbers);
				if ( mountCount > 0 ) then
					mountNumber = math.floor(math.random() * mountCount + 1);
					if ( mountNumber > mountCount ) then
						mountNumber = mountCount;
					end;
					CallCompanion("MOUNT",mountNumbers[mountNumber]);
					return true;
				end;
			end;
		end;
	end;
	return false;
end

function MM:Mount()
	if ( ( ( IsMounted() == 1 ) or ( CanExitVehicle() == 1 ) ) and ( IsFlying() == nil ) ) then
		if ( IsMounted() ) then
			Dismount();
			return true;
		else
			VehicleExit();
			return true;
		end
	else
		local mountCount = GetNumCompanions("MOUNT");
		if ( mountCount == 0 ) then
			-- Keine Mounts, keine Aktion
			return;
		end;
		local mountNumber = 0;
		mountCount = 0;
		local mountNumbers = {};
		if ( MM:isFlyableArea() == 1 ) then
			local mountTables = {
				MM:IntersectTables(flyingMounts),
				MM:IntersectTables(groundMounts),
				MM:IntersectTables(walkRidingMounts),
			};
			for i = 1, table.getn(mountTables) do
				if ( mountCount == 0 ) then
					mountNumbers = MM:getMountNumbers(mountTables[i]);
					mountCount = table.getn(mountNumbers);
					if ( mountCount > 0 ) then
						mountNumber = math.floor(math.random() * mountCount + 1);
						if ( mountNumber > mountCount ) then
							mountNumber = mountCount;
						end;
						CallCompanion("MOUNT",mountNumbers[mountNumber]);
						return true;
					end;
				end;
			end;
		else
			return MM:MountGround();
		end;
	end;
	return false;
end

function MM:listMountAmounts()
	local compCount = GetNumCompanions("MOUNT");
	local qiraj = 0;
	local fastR = 0;
	local fastF = 0;
	local walkR = 0;
	local water = 0;
	local fwate = 0;
	for i = 1 , compCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		if ( MM:findValue(qirajRidingMounts,creatureSpellID) ) then
			qiraj = qiraj + 1;
		end;
		if ( MM:findValue(groundMounts,creatureSpellID) ) then
			fastR = fastR + 1;
		end;
		if ( MM:findValue(flyingMounts,creatureSpellID) ) then
			fastF = fastF + 1;
		end;
		if ( MM:findValue(walkRidingMounts,creatureSpellID) ) then
			walkR = walkR + 1;
		end;
		if ( MM:findValue(waterMounts,creatureSpellID) ) then
			water = water + 1;
		end;
		if ( MM:findValue(fastWaterMounts,creatureSpellID) ) then
			fwate = fwate + 1;
		end;
	end;
	DEFAULT_CHAT_FRAME:AddMessage(qiraj.." "..L["Qiraj Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(walkR.." "..L["Walk Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(water.." "..L["Water Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fwate.." "..L["fast Water Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fastR.." "..L["Fast Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fastF.." "..L["Fast Flying Mounts"]);
	return compCount;
end;

function MM:getMountNumbers(myMountTable)
	local compCount = GetNumCompanions("MOUNT");
	local goodNumbers = {};
	for i = 1 , compCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		if ( MM:findValue(myMountTable,creatureSpellID) and MM:hasSkillFor(creatureSpellID) ) then
			table.insert(goodNumbers,i);
		end;
	end;
	return goodNumbers;
end;

function MM:isFlyableArea()
	if ( IsSwimming() == 1 ) then return 0; end;
	if ( MM:findValue(noFlyZones,GetRealZoneText()) ) then
		return 0;
	end;
	if ( (IsInInstance() == 1) and (MM:findValue(noFlyInstances,GetRealZoneText())) ) then
		return 0;
	end;
	
	local allowedToFly = false;
	local spellType, spellId = GetSpellBookItemInfo(L["Expert Riding"]);
	if ( spellType == "SPELL" ) then
		allowedToFly = true;
	end;
	if ( GetCurrentMapContinent() == L["Eastern Kingdoms"] ) then
		if ( L["Shimmering Expanse"] == GetRealZoneText() ) then
			if ( L["Nespirah"] == GetSubZoneText() ) then
				return 0;
			end;
		end;
		local i = 1;
		allowedToFly = false;
		local spellType, spellId = GetSpellBookItemInfo(L["Flight Master's License"]);
		if ( spellType == "SPELL" ) then
			allowedToFly = true;
		end;
	end;
	if ( GetCurrentMapContinent() == L["Kalimdor"] ) then
		local i = 1;
		allowedToFly = false;
		local spellType, spellId = GetSpellBookItemInfo(L["Flight Master's License"]);
		if ( spellType == "SPELL" ) then
			allowedToFly = true;
		end;
	end;
	
	if ( GetCurrentMapContinent() == L["Northrend"] ) then
		local i = 1;
		allowedToFly = false;
		local spellType, spellId = GetSpellBookItemInfo(L["Cold Weather Flying"]);
		if ( spellType == "SPELL" ) then
			allowedToFly = true;
		end;
	end;
	if ( L["Wintergrasp"] == GetRealZoneText() ) then
		local pvpID,localizedName,isActive,canQueue,startTime,canEnter = GetWorldPVPAreaInfo(worldPVPZones['Wintergrasp']);
		if ( isActive ) then
			return 0;
		end;
	end;
	if ( GetCurrentMapContinent() == L["The Maelstroem"] ) then
		if ( L["Deepholm"] == GetRealZoneText() ) then
			if ( L["Crumbling Depths"] == GetSubZoneText() ) then
				return 0;
			end;
		end;
		local i = 1;
		allowedToFly = false;
		local spellType, spellId = GetSpellBookItemInfo(L["Flight Master's License"]);
		if ( spellType == "SPELL" ) then
			allowedToFly = true;
		end;
	end;
	if ( GetCurrentMapContinent() == L["Pandaria"] ) then
		local i = 1;
		allowedToFly = false;
		local spellType, spellId = GetSpellBookItemInfo(L["Wisdom of the Four Winds"]);
		if ( spellType == "SPELL" ) then
			allowedToFly = true;
		end;
	end;
	if ( not allowedToFly ) then
		return 0;
	end;
	return IsFlyableArea();
end

function MM:ListMounts()
	local mountCount = GetNumCompanions("MOUNT");
	local mountIDs = {};
	local mountNames = {};
	for i = 1, mountCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		table.insert(mountIDs,creatureSpellID);
		table.insert(mountNames,creatureName);
	end
	for i = 1, table.getn(mountIDs) do
		DEFAULT_CHAT_FRAME:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
	end
end

function MM:ListUnknownMounts()
	local mountCount = GetNumCompanions("MOUNT");
	local mountIDs = {};
	local mountNames = {};
	for i = 1, mountCount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		if ( not ( MM:findValue(qirajRidingMounts,creatureSpellID)
			or MM:findValue(waterMounts,creatureSpellID)
			or MM:findValue(fastWaterMounts,creatureSpellID)
			or MM:findValue(groundMounts,creatureSpellID)
			or MM:findValue(flyingMounts,creatureSpellID)
			or MM:findValue(walkRidingMounts,creatureSpellID)
		) ) then
			table.insert(mountIDs,creatureSpellID);
			table.insert(mountNames,creatureName);
		end;
	end
	if ( table.getn(mountIDs) == 0 ) then
		DEFAULT_CHAT_FRAME:AddMessage(L["All your mounts are known to this addon."]);
	end
	for i = 1, table.getn(mountIDs) do
		DEFAULT_CHAT_FRAME:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
	end
end

-- Favourites and dislikes

function MM:ToggleFavourite(info, value)
	-- \124cff71d5ff\124Hspell:16056\124h[Ancient Frostsaber]\124h\124r
	--- |cff71d5ff|Hspell:16056|h[Ancient Frostsaber]|h|r
	if ( string.len(value) > 0 ) then
		local paramArray = MM:strsplit(":",value);
		local spellid = MM:strsplit("|",paramArray[2]);
		if ( MM:findValue(MikaMounterPrefs.favourites,tonumber(spellid[1])) ) then
			local index = MM:getKey(MikaMounterPrefs.favourites,tonumber(spellid[1]));
			table.remove(MikaMounterPrefs.favourites,index);
			DEFAULT_CHAT_FRAME:AddMessage(L['Removed: ']..value);
		else
			table.insert(MikaMounterPrefs.favourites,tonumber(spellid[1]));
			DEFAULT_CHAT_FRAME:AddMessage(L['Added: ']..value);
		end;
	end;
end

function MM:ToggleDislike(info, value)
	-- \124cff71d5ff\124Hspell:16056\124h[Ancient Frostsaber]\124h\124r
	--- |cff71d5ff|Hspell:16056|h[Ancient Frostsaber]|h|r
	if ( string.len(value) > 0 ) then
		local paramArray = MM:strsplit(":",value);
		local spellid = MM:strsplit("|",paramArray[2]);
		if ( MM:findValue(MikaMounterPrefs.dislikes,tonumber(spellid[1])) ) then
			local index = MM:getKey(MikaMounterPrefs.dislikes,tonumber(spellid[1]));
			table.remove(MikaMounterPrefs.dislikes,index);
			DEFAULT_CHAT_FRAME:AddMessage(L['Removed: ']..value);
		else
			table.insert(MikaMounterPrefs.dislikes,tonumber(spellid[1]));
			DEFAULT_CHAT_FRAME:AddMessage(L['Added: ']..value);
		end;
	end;
end


function MM:ToggleFavourites()
	if ( MikaMounterPrefs.favouritesActive ) then
		MikaMounterPrefs.favouritesActive = false;
		DEFAULT_CHAT_FRAME:AddMessage(L["Favourites are now inactive."]);
	else
		MikaMounterPrefs.favouritesActive = true;
		DEFAULT_CHAT_FRAME:AddMessage(L["Favourites are now active."]);
	end
end

function MM:ToggleDislikes()
	if ( MikaMounterPrefs.dislikesActive ) then
		MikaMounterPrefs.dislikesActive = false;
		DEFAULT_CHAT_FRAME:AddMessage(L["Dislikes are now inactive."]);
	else
		MikaMounterPrefs.dislikesActive = true;
		DEFAULT_CHAT_FRAME:AddMessage(L["Dislikes are now active."]);
	end
end

function MM:IntersectTables(table2)
	local returnTable = {};
	if ( MikaMounterPrefs.favouritesActive ) then
		local table1 = MikaMounterPrefs.favourites;
		for i = 1, table.getn(table1) do
			if ( MM:findValue(table2,table1[i]) ) then
				table.insert(returnTable,table1[i]);
			end;
		end;
		if ( table.getn(returnTable) == 0 ) then
			returnTable = table2;
		end;
	else
		if ( table.getn(returnTable) == 0 ) then
			returnTable = table2;
		end;
	end;
	if ( MikaMounterPrefs.dislikesActive ) then
		local table1 = MikaMounterPrefs.dislikes;
		if ( table.getn(returnTable) == table.getn(table2) ) then
			returnTable = {};
			for i = 1, table.getn(table2) do
				if ( not (MM:findValue(table1,table2[i])) ) then
					table.insert(returnTable,table2[i]);
				end;
			end;
		end;
	else
		if ( table.getn(returnTable) == 0 ) then
			returnTable = table2;
		end;
	end;
	return returnTable;
end

-- Oculus functions
function MM:UNIT_INVENTORY_CHANGED(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:ITEM_LOCK_CHANGED(event, bag, item)
	if ( not ( item == nil ) ) then
		MM:CheckBind();
	end;
end
function MM:UNIT_PET(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:UNIT_AURA(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:UNIT_ENTERED_VEHICLE(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:WORLD_MAP_UPDATE(event)
	MM:CheckBind();
end;

function MM:CheckBind()
	if ( GetBindingKey("MOUNT_AUTO") ) then
		if not ( ( IsMounted() == 1 ) or ( CanExitVehicle() == 1 ) ) then
			for bagID = 0, NUM_BAG_SLOTS do
				for slotID = 1 , GetContainerNumSlots(bagID) do
					local itemLink = GetContainerItemLink(bagID, slotID);
					if ( not (itemLink == nil) ) then
						if ( GetRealZoneText() == L["The Oculus"] ) then
							if ( ( string.find(itemLink,"item:37859:") ) or ( string.find(itemLink,"item:37815:") ) or ( string.find(itemLink,"item:37860:") ) ) then
								MM.actionbutton:SetAttribute("item",bagID.." "..slotID);
								SetOverrideBindingClick(MM.actionbutton, false, GetBindingKey("MOUNT_AUTO"), "MountButton", "Hotkey1");
								return;
							elseif ( string.find(itemLink,"item:37011:") ) then
								MM.actionbutton:SetAttribute("item",bagID.." "..slotID);
								SetOverrideBindingClick(MM.actionbutton, false, GetBindingKey("MOUNT_AUTO"), "MountButton", "Hotkey1");
								return;
							end;
						elseif ( string.find(itemLink,"item:37011:") ) then
							MM.actionbutton:SetAttribute("item",bagID.." "..slotID);
							SetOverrideBindingClick(MM.actionbutton, false, GetBindingKey("MOUNT_AUTO"), "MountButton", "Hotkey1");
							return;
						end;
					end;
				end;
			end;
		end;
	end;
	ClearOverrideBindings(MM.actionbutton);
end

function MM:Nothing(info)

end;


function MM:hasSkillFor(creatureSpellID)
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	if ( prof1 ) then
		local name1, _, _, _, _, _, _, _ = GetProfessionInfo(prof1);
		if ( skillMounts[creatureSpellID] == name1 ) then
			return true;
		end
	end;
	if ( prof2 ) then
		local name2, _, _, _, _, _, _, _ = GetProfessionInfo(prof2);
		if ( skillMounts[creatureSpellID] == name2 ) then
			return true;
		end
	end;
	if ( skillMounts[creatureSpellID] == L["Cloud Serpent Riding"] ) then
		local spellType, spellId = GetSpellBookItemInfo(L["Cloud Serpent Riding"]);
		if ( spellType == "SPELL" ) then
			return true;
		end;
	end;
	return (skillMounts[creatureSpellID] == nil);
end

function MM:findValue(myTable, key)
	for i = 1, table.getn(myTable) do
		if ( myTable[i] == key ) then
			return true;
		end;
	end
	return false;
end

function MM:getKey(myTable, key)
	for i = 1, table.getn(myTable) do
		if ( myTable[i] == key ) then
			return i;
		end;
	end
	return false;
end

function MM:strsplit(delimiter, text)
	local list = {}
	local pos = 1
	if strfind("", delimiter, 1) then -- this would result in endless loops
		error("delimiter matches empty string!")
	end
	while 1 do
		local first, last = strfind(text, delimiter, pos)
		if first then -- found?
			tinsert(list, strsub(text, pos, first-1))
			pos = last+1
		else
			tinsert(list, strsub(text, pos))
			break
		end
	end
	return list
end

function MM:OnEnable()

end

function MM:OnDisable()

end
